#include "sys.h"
#include "usart.h"		
#include "delay.h"	
#include "led.h" 
#include "key.h"
#include "lcd.h"
#include "ds18b20.h"	
#include "includes.h"
	 
//Mini STM32չʵ 8
//ucos ʵ
//ԭ@ALIENTEK
//֧֣www.openedv.com

 
//ջС
#define LED_STK_SIZE     128
#define LED1_STK_SIZE    64
#define LCD_STK_SIZE     128
#define START_STK_SIZE   512

//ȼ
#define LED_TASK_Prio       8
#define LED1_TASK_Prio      9
#define LCD_TASK_Prio       6
#define START_TASK_Prio     10

//ջ
OS_STK  TASK_LED1_STK[LED_STK_SIZE];
OS_STK  TASK_LED_STK[LED_STK_SIZE];
OS_STK  TASK_LCD_STK[LCD_STK_SIZE];
OS_STK  TASK_START_STK[START_STK_SIZE];
//
void TaskStart(void *pdata);
void TaskLed(void *pdata);
void TaskLed1(void *pdata);
void TaskLCD(void *pdata);
//ϵͳʱú
void SysTick_Configuration(void);
short tempset=10; 
short temp; 	 
//Mini STM32ucos
//ucos2.52ں.
//ԭ@ALIENTEK
//www.openedv.com
//2010.12.15			 
int main(void)
{			 	   
	Stm32_Clock_Init(9); //ϵͳʱ
//	delay_init(72);	     //ʱʼ 
	uart_init(72,9600);	 //ڳʼΪ9600
	LED_Init();		  	 //ʼLEDӵӲӿ  
	LCD_Init();
	KEY_Init();          //ʼ밴ӵӲӿ
	DS18B20_Init();
	SysTick_Configuration();
	OSInit();
	OSTaskCreate( TaskStart,	//task pointer
					(void *)0,	//parameter
					(OS_STK *)&TASK_START_STK[START_STK_SIZE-1],	//task stack top pointer
					START_TASK_Prio );	//task priority
	
	OSStart();
	return 0;	   
}
//ʼ
void TaskStart(void * pdata)
{
	pdata = pdata; 
	OS_ENTER_CRITICAL();   
	OSTaskCreate(TaskLed, (void * )0, (OS_STK *)&TASK_LED_STK[LED_STK_SIZE-1], LED_TASK_Prio);
	OSTaskCreate(TaskLed1, (void * )0, (OS_STK *)&TASK_LED1_STK[LED1_STK_SIZE-1], LED1_TASK_Prio);
	OSTaskCreate(TaskLCD, (void * )0, (OS_STK *)&TASK_LCD_STK[LCD_STK_SIZE-1], LCD_TASK_Prio);
	OSTaskSuspend(START_TASK_Prio);	//suspend but not delete
	OS_EXIT_CRITICAL();
}
//1
//DS0.
void TaskLed(void *pdata)
{
	while(1)
	{

		if(KEY0==0)
		{
			delay_ms(10);
			if(KEY0==0)
			{						   						 		
				tempset++;
				if(tempset>30)	
				tempset=10;	
			}
			while(!KEY0);									
		}

		else if(KEY1==0)
		{
			delay_ms(10);
			if(KEY1==0)
			{
				tempset--;
				if(tempset<10)
				tempset=30;		
			} 
			while(!KEY1);	
		}
	  	if(tempset*10>temp)
		{	
		//	LCD_ShowString(30,180,"2012/4/6"); 
			OSTaskSuspend (LED1_TASK_Prio);

		}
		else
		{
			OSTaskResume (LED1_TASK_Prio);
		}
	  	OSTimeDlyHMSM(0,0,0,30);

	}
}
//2
//DS1.
void TaskLed1(void *pdata)
{
	while(1)
	{
		LED0=!LED0;
		LED1=!LED1;  
		OSTimeDlyHMSM(0,0,0,500);	
	}
}
//LCDʾ.
void TaskLCD(void *pdata)
{  


   	 LCD_Clear(WHITE) ;
	while(1)
	{

		if(DS18B20_Init()==1)//ʼDS18B20,18B20
		{
		
			LCD_ShowString(60,150,"DS18B20 Check Failed!");
			OSTimeDlyHMSM(0,0,0,200);	
			LCD_ShowString(44,170,"Please Check!         ");
			OSTimeDlyHMSM(0,0,0,100);	
		  goto end;

		}
		
	
		POINT_COLOR=RED;	  
		LCD_ShowString(30,50,"Mini STM32 ^_^");	
		LCD_ShowString(30,70,"2.4'/2.8' TFTLCD TEST");	
		LCD_ShowString(30,90,"ATOM@ALIENTEK");
		LCD_ShowString(30,110,"2012/4/1"); 
	
		LCD_ShowString(60,130,"DS18B20 Ready!         ");	 
 		POINT_COLOR=BLUE;//Ϊɫ	   
		LCD_ShowString(60,150, "Temperate:   . C      ");
	  	LCD_ShowString(44,170, "SETTemperate:    C    ");
		temp=DS18B20_Get_Temp();
		if(temp<0)
		{
			temp=-temp;
			LCD_ShowChar(140,150,'-',16,0);//ʾ	
		}						 
		LCD_ShowNum(148,150,temp/10,2,16);//ʾ¶ֵ	  
		LCD_ShowNum(172,150,temp%10,1,16);//ʾ¶ֵ

 		LCD_ShowNum(148,170,tempset/10,1,16);//ʾ¶ֵ	  
		LCD_ShowNum(156,170,tempset%10,1,16);//ʾ¶ֵ

		
	end:
		OSTimeDlyHMSM(0,0,0,200);

			
	}
}	  
//ϵͳʱжϷ
void SysTick_Handler(void)
{
	OS_ENTER_CRITICAL(); /* Tell uC/OS-II that we are starting an ISR  */
    OSIntNesting++;
    OS_EXIT_CRITICAL();

    OSTimeTick();        /* Call uC/OS-II's OSTimeTick()               */

    OSIntExit();         /* Tell uC/OS-II that we are leaving the ISR  */
}
//ϵͳʱã1msһж
void SysTick_Configuration(void)
{
 	SysTick->CTRL&=~(1<<2);//SYSTICKʹⲿʱԴ
	SysTick->CTRL|=1<<1;   //SYSTICKж
	SysTick->LOAD=9000;    //1msж
	//bit2,ѡⲿʱ  HCLK/8
	MY_NVIC_Init(3,3,SystemHandler_SysTick,2);//2ȼ 
	SysTick->CTRL|=1<<0;   //SYSTICK
}




















